
function getElementSize(el, axis, noWidth){
	if (!axis) return {
		width: getElementSize(el, 'h', noWidth),
		height: getElementSize(el, 'v', noWidth)
	};
	var styles = window.getComputedStyle(el);
	const init = noWidth ? 0 : (axis == 'h' ? el.offsetWidth : el.offsetHeight);
	return styleAttributes[axis].reduce(
		(sum, style) => sum + parseInt(styles[style], 10), init
	);
}

function getElementPosition(fromElement){
	let el = fromElement, padding = {x: 0, y:0};
	while (el = el.parentElement) {
		const elStyle = getElementSize(el, null, true);
		padding.x += elStyle.width
		padding.y += elStyle.height
	}
	return padding;
}

const styleAttributes = {
	h: ['marginLeft', 'marginRight', 'borderLeftWidth', 'borderRightWidth'],
	v: ['marginTop', 'marginBottom', 'borderTopWidth', 'borderBottomWidth']
};

const onEvent = {
   click: 'ontouchstart' in window ? 'touchstart' : 'click',
   down: 'ontouchstart' in window ? 'touchstart' : 'mousedown',
   move: 'ontouchmove' in window ? 'touchmove' : 'mousemove',
   up: 'ontouchend' in window ? 'touchend' : 'mouseup'
};

module.exports = {
	getElementSize: getElementSize,
	getElementPosition: getElementPosition,
	styleAttributes: styleAttributes,
	onEvent: onEvent
}
